
let isGood = true;
//permet de traiter la liste des animes données par rapport à une recherche ou à un triage spécifique.
function traiterAnimes(page, callback){
    let liste= "";
    let lien ="";
    let nbAnimes;
    page--;
    //si la barre de recherche n'est pas vide, on va changer le lien.
    if (document.getElementById("chercher").value != "") {
        document.getElementById("sort").setAttribute("disabled", "disabled");
        lien = "https://kitsu.io/api/edge/anime?page[offset]="+page*20+"&filter[text]="+document.getElementById("chercher").value+"&page[limit]=20";

    }else{
        if (document.getElementById("sort").hasAttribute("disabled")) {
            document.getElementById("sort").removeAttribute("disabled");
        }
        lien = "https://kitsu.io/api/edge/anime?sort="+document.getElementById("sort").value+"&page[offset]="+page*20+"&page[limit]=20";
    }
    //récupération des animes et création de la liste
     $.getJSON(lien,undefined,function(animes){

        nbAnimes = animes.meta.count;
        console.log(nbAnimes);
        if ((page+1) == Math.ceil(nbAnimes/20)) {
            hideNext(true);
        }else{
            hideNext(false);
        }

        if (animes.meta.count > 20) {
            nbAnimes = 20;
        }else{
            nbanimes = animes.meta.count;
        }
        for (let index = 0; index < nbAnimes; index++) {
            //on vérifie si l'anime a un rank
            if(animes.data[index].attributes.ratingRank !== null){
                //on vérifie si l'anime a une image de poster
                if (animes.data[index].attributes.posterImage !== null) {
                    //on vérifie si l'anime a un titre en anglais
                    if(animes.data[index].attributes.titles.en_us !== undefined){
                        liste=liste+"<ul class='anime'><img class='animage' src='"+animes.data[index].attributes.posterImage.tiny+"'><a class='titre' href='pages/anime.html?id="+animes.data[index].id+"&page="+(page+1)+"'>"+animes.data[index].attributes.titles.en_us+"</a><a class='rank'> "+animes.data[index].attributes.averageRating+" </a></ul>"
                    }else if(animes.data[index].attributes.titles.en_jp !== undefined){
                        liste=liste+"<ul class='anime'><img class='animage' src='"+animes.data[index].attributes.posterImage.tiny+"'><a class='titre' href='pages/anime.html?id="+animes.data[index].id+"&page="+(page+1)+"'>"+animes.data[index].attributes.titles.en_jp+"</a><a class='rank'> "+animes.data[index].attributes.averageRating+" </a></ul>"
                    }else{
                        liste=liste+"<ul class='anime'><img class='animage' src='"+animes.data[index].attributes.posterImage.tiny+"'><a class='titre' href='pages/anime.html?id="+animes.data[index].id+"&page="+(page+1)+"'>"+animes.data[index].attributes.titles.en+"</a><a class='rank'> "+animes.data[index].attributes.averageRating+" </a></ul>"
                    }
                }else{
                   if(animes.data[index].attributes.titles.en_us !== undefined){
                        liste=liste+"<ul class='anime'><img class='animage' src='images/pasDimage.png'><a class='titre' href='pages/anime.html?id="+animes.data[index].id+"&page="+(page+1)+"'>"+animes.data[index].attributes.titles.en_us+"</a><a class='rank'> "+animes.data[index].attributes.averageRating+" </a></ul>"
                    }else if(animes.data[index].attributes.titles.en_jp !== undefined){
                        liste=liste+"<ul class='anime'><img class='animage' src='images/pasDimage.png'><a class='titre' href='pages/anime.html?id="+animes.data[index].id+"&page="+(page+1)+"'>"+animes.data[index].attributes.titles.en_jp+"</a><a class='rank'> "+animes.data[index].attributes.averageRating+" </a></ul>"
                    }else{
                        liste=liste+"<ul class='anime'><img class='animage' src='images/pasDimage.png'><a class='titre' href='pages/anime.html?id="+animes.data[index].id+"&page="+(page+1)+"'>"+animes.data[index].attributes.titles.en+"</a><a class='rank'> "+animes.data[index].attributes.averageRating+" </a></ul>"
                    } 
                }

                
            }else{

                if (animes.data[index].attributes.posterImage !== null) {
                    if(animes.data[index].attributes.titles.en_us !== undefined){
                        liste=liste+"<ul class='anime'><img class='animage' src='"+animes.data[index].attributes.posterImage.tiny+"'><a class='titre' href='pages/anime.html?id="+animes.data[index].id+"&page="+(page+1)+"'>"+animes.data[index].attributes.titles.en_us+"</a><a class='rank'> N/A </a></ul>"
                    }else if(animes.data[index].attributes.titles.en_jp !== undefined){
                        liste=liste+"<ul class='anime'><img class='animage' src='"+animes.data[index].attributes.posterImage.tiny+"'><a class='titre' href='pages/anime.html?id="+animes.data[index].id+"&page="+(page+1)+"'>"+animes.data[index].attributes.titles.en_jp+"</a><a class='rank'> N/A </a></ul>"
                    }else{
                        liste=liste+"<ul class='anime'><img class='animage' src='"+animes.data[index].attributes.posterImage.tiny+"'><a class='titre' href='pages/anime.html?id="+animes.data[index].id+"&page="+(page+1)+"'>"+animes.data[index].attributes.titles.en+"</a><a class='rank'> N/A </a></ul>"
                    } 
                } else {
                   if(animes.data[index].attributes.titles.en_us !== undefined){
                        liste=liste+"<ul class='anime'><img class='animage' src='images/pasDimage.png'><a class='titre' href='pages/anime.html?id="+animes.data[index].id+"&page="+(page+1)+"'>"+animes.data[index].attributes.titles.en_us+"</a><a class='rank'> N/A </a></ul>"
                    }else if(animes.data[index].attributes.titles.en_jp !== undefined){
                        liste=liste+"<ul class='anime'><img class='animage' src='images/pasDimage.png'><a class='titre' href='pages/anime.html?id="+animes.data[index].id+"&page="+(page+1)+"'>"+animes.data[index].attributes.titles.en_jp+"</a><a class='rank'> N/A </a></ul>"
                    }else{
                        liste=liste+"<ul class='anime'><img class='animage' src='images/pasDimage.png'><a class='titre' href='pages/anime.html?id="+animes.data[index].id+"&page="+(page+1)+"'>"+animes.data[index].attributes.titles.en+"</a><a class='rank'> N/A </a></ul>"
                    } 
                }

                
            }
        }
        //retour de la liste d'animes
        callback(liste);
    });
}
//permet de récupérer l'id de l'anime depuis la barer de recherche
function traiterAnime(callback){
    let queryString = window.location.search;
    let urlParams = newURLSearchParams(queryString);
    let id = urlParams.id
    chercherStreaming(id, callback);
}
//permet de créer la page des informations sur un anime 
function creerPage(id, streaming, categories, callback){

    $.getJSON("https://kitsu.io/api/edge/anime/"+id,undefined,function(anime){
        let banner = "";
        let cover = "";
        let video = "";
        if (anime.data.attributes.youtubeVideoId != null) {
            if (!isGood) {
                video = "pSWqEz3O6Q8";
            }else{
                video = anime.data.attributes.youtubeVideoId
            }
        }else{
            video = "pSWqEz3O6Q8";
        }
        if (anime.data.attributes.coverImage != null) {
            banner = anime.data.attributes.coverImage.tiny;
        }else{
            banner = "../images/sansBanner.png"
        }

        if (anime.data.attributes.posterImage != null) {
            cover = anime.data.attributes.posterImage.small;
        } else {
            cover = "../images/pasDimage.png"
        }
        let contenu =
        "<div class='allerEnDessous'>"+
        "<div id='tete'>"+
        "<div id='titreMilieu'>"+
          "<a id='animeTitre'>"+anime.data.attributes.canonicalTitle+"</a>"+
       "</div>"+
      "</div>"+
      "</div>"+
      "<div id='informations'>"+
      "<div id='imgEtInfos'>"+
      "<div id='imageEtAutres'>"+
      "<img id='imageAnime' src='"+cover+"'/>"+
      "<div id='strGenCat'>"+
            "<div id='streaming'>"+
            "<a class='petitTitre' id='streamingTitre'>streaming :</a><br>"+
              streaming+
            "</div>"+
            "<div id='categories'>"+
              "<a class='petitTitre' id='categoriesTitre'>catégories :</a><br>"+
              categories+
            "</div>"+
          "</div>"+
        "</div>"+
        "<div id='description'>"+
          "<a class='petitTitre' id='synopsisTitre'>synopsis :</a>"+
          "<p id='synopsis'>"+anime.data.attributes.synopsis+"</p>"+
          "<div id='infosup'>"+
            "<a class='petitTitre' id='infosupTitre'>infos supplémentaires :</a>"+
            "<table id='infos' cellspaceing=50>"+
              "<tr>"+
                "<td> date de début de parution : "+anime.data.attributes.startDate+"</td>"+
                "<td>nombres d'épisodes : "+anime.data.attributes.episodeCount+"</td>"+
              "</tr>"+
              "<tr>"+
                "<td> date de fin de parution : "+anime.data.attributes.endDate+"</td>"+
                "<td>durée d'un épisode : "+anime.data.attributes.episodeLength+" minutes</td>"+
              "</tr>"+
              "<tr>"+
                "<td>statut:</td>"+
                "<td>durée totale : "+anime.data.attributes.totalLength+" minutes</td>"+
              "</tr>"+
              "<tr>"+
                "<td> limite d'âge :"+anime.data.attributes.ageRating+" - "+anime.data.attributes.ageRatingGuide+"</td>"+
              "</tr>"+
            "</table>"+
          "</div>"+
          "<div id='trailer'>"+
          "<a class='petitTitre' id='trailerTitre'>trailer :</a><br>"+
          "<iframe width='420' height='345' src='https://www.youtube.com/embed/"+video+"'></iframe>"+
        "</div>"+
        "</div>"+
        "</div>"+
      "</div>";
      callback(contenu, banner);
    });
}
//permet d'afficher les boutons pour accéder aux différents sites de streaming
function chercherStreaming(id, callback){
    

    $.getJSON("https://kitsu.io/api/edge/anime/"+id+"/streaming-links",undefined,function(liens){
        let streaming = "";
        let image = "";
        let lienStr = "";
    for (let index = 0; index < liens.meta.count; index++) {
        if (liens.meta.count == 0) {
            streaming = "aucun liens de streaming"
        } else {
            lienStr = liens.data[index].attributes.url;
            if (lienStr.includes("crunchyroll")) {
                image = "../images/crunch.png";
            }else if (lienStr.includes("netflix")) {
                image = "../images/N.png";
            }else if (lienStr.includes("wakanim")) {
                image = "../images/waka.png";
            }else if (lienStr.includes("funimation")) {
                image = "../images/funi.png";
            }else if (lienStr.includes("hulu")) {
                image = "../images/h.png";
            }else if (lienStr.includes("vrv")) {
                image = "../images/vrv.png";
            }else{
                image = "../images/justeLogo.png";
            }
            streaming += "<a href='"+liens.data[index].attributes.url+"' target='_blank'><img src='"+image+"' class='site'></a>";
        }
    }
    chercherCategories(id, streaming, callback);
    });
}
//permet d'afficher la liste des catégories appartenant à l'anime demandé
function chercherCategories(id, streaming, callback){
    
    $.getJSON("https://kitsu.io/api/edge/anime/"+id+"/categories",undefined,function(cat){
        let categories = "";
    
    
        for (var index in cat.data) {
        if (cat.meta.count == 0) {
            	categories = "pas de catégories  "
        }else{
            categories += cat.data[index].attributes.title+", "
        }
    }
        categories = categories.substr(0, categories.length -2);
        checkVideo(id, streaming, categories, callback);
    });
}
//perme de récuérer le paramètre de l'id de l'anime mis en paramètre dans le lien 
function newURLSearchParams(url) {
    var queryStart = url.indexOf("?") + 1,
        queryEnd   = url.indexOf("#") + 1 || url.length + 1,
        query = url.slice(queryStart, queryEnd - 1),
        pairs = query.replace(/\+/g, " ").split("&"),
        parms = {}, i, n, v, nv;

    if (query === url || query === "") return;

    for (i = 0; i < pairs.length; i++) {
        nv = pairs[i].split("=", 2);
        n = decodeURIComponent(nv[0]);
        v = decodeURIComponent(nv[1]);

        if (!parms.hasOwnProperty(n)) parms[n] = [];
        parms[n].push(nv.length === 2 ? v : null);
    }
    return parms;
}
//vérifie la largeur, principalement de la vidéo
function checkWidth(width, id, streaming, categories, callback){
    if(width === 120){
        isGood = false;
    }
    creerPage(id, streaming, categories, callback);
}
//permet de vérifier si un trailer exisste ou pas.
function checkVideo(id, streaming, categories, callback){
    $.getJSON("https://kitsu.io/api/edge/anime/"+id,undefined,function(anime){
        let img = new Image();
        img.src = "http://img.youtube.com/vi/" + anime.data.attributes.youtubeVideoId + "/mqdefault.jpg";
        img.onload = function(){
            checkWidth(this.width, id, streaming, categories, callback)
        }
    });
}
