//initialisation de la page
let page;
function initCtrl(){
    if (document.getElementById("chercher").hasAttribute("disabled")) {
        document.getElementById("chercher").removeAttribute("disabled");
    }
    scrollUp();
    buttonToTop(); 
    if (page == null) {
        page = 1;
    }
    if (page == 1) {
        document.getElementById("prev").style.visibility = "hidden";
    }else{
        document.getElementById("prev").style.visibility = "visible";
    }
    traiterAnimes(page, afficherAnimes);
}
//affiche la liste des animes sur la page
function afficherAnimes(animes){
    document.getElementById("list").innerHTML = animes;
}
//page précédente
function prevPage(){
    page--;
    document.getElementById("nbPage").innerText=page;
    initCtrl();
}
//page suivante
function nextPage(){
    page++;
    document.getElementById("nbPage").innerText=page;
    initCtrl();
}
//ramène à la première page
function resetpage(){
    document.getElementById("nbPage").innerText = 1;
}
//remonte en haut de la page
function scrollUp(){
    document.body.scrollTop = 0;
    document.documentElement.scrollTop = 0;
}
//permet d'afficher le bouton pour remonter uniquement lorsque l'on a descendu dans la page
function buttonToTop(){
    console.log("scroll")
    if (document.body.scrollTop > 20 || document.documentElement.scrollTop > 20) {
        document.getElementById("toTop").style.display = "block";
      } else {
        document.getElementById("toTop").style.display = "none";
      }
}
//cacher le bouton de la page suivante à la dernière page
function hideNext(hide){
    if(hide){
        document.getElementById("next").style.visibility = "hidden";
    }else{
        document.getElementById("next").style.visibility = "visible";
    }
}
//affiche la page d'un anime sur lequel on a cliqué 
function afficherAnime(page, banner){
    document.getElementById("chercher").setAttribute("disabled", "disabled")
    document.getElementById("chercher").style.opacity = "80%";
    document.getElementById("overlap").innerHTML = page;
    document.getElementById("tete").style.backgroundImage = "url("+banner+")";
}
//retourner à la page d'acceuil
function acceuil(){
    window.location.href = "/animust/index.html"
}
//recharge la page lors d'une recherche
function recherche() {
    resetpage();
    initCtrl();
}
//recherche d'animes avec la barre de recherche et affiche la liste
function chercherAnime(){
    traiterAnime(afficherAnime);
}
//permet de changer la page actuelle. Utilisée pour aller sur un site de streaming.
function streaming(lien){
    window.location.replace(lien);
}
//permet de revenir à où vous étiez précédemment
function retour(){
    let urlParams = newURLSearchParams(window.location.search);
    page = urlParams.page;
    window.history.back();
    
}